#encoding=utf-8
import os,sys
path = os.path.abspath(__file__)
absdir = path[0:path.rfind('/')]
sys.path.append(absdir[0:absdir.rfind('/',0,len(absdir))])

import threading
from time import sleep
from common.enum import status
from utils import decodeID,generateID
import xmlrpclib
class Monitor:
    #该lock是为了和receivermessage进行同步
    lock = threading.Lock()
    def __init__(self,processPool,workerPool,taskPool):
        self.processPool = processPool
        self.workerPool = workerPool
        self.taskPool = taskPool
        self.workerQueue = self.workerPool.get_workerqueue()
        self.th = threading.Thread(target=self.polling, args=())
        self.th.setDaemon(True)
        self.th.start()
    def get_lock(self):
        Monitor.lock.acquire()
    def release_lock(self):
        Monitor.lock.release()
    def polling(self):
        #使用一个map来记录每个worker的状态，对同一个worker，只有连续三次检测到相同的状态时，才对该状态做出反应(response_with_workstatus)
        workerstatusMap = dict()
        while True:
            sleep(5)
            for i in range(len(self.workerQueue)):    
                worker_ip_port = self.workerQueue[i][0]
                workerstatus = -1
                try:
                    workerstatus = self.get_workerstatus(worker_ip_port)
                except Exception,e:
                    #如果异常，说明机器关闭或程序退出,也可能是网络不通
                    workerstatus = 3
                    
                if not workerstatusMap.has_key(worker_ip_port):
                    workerstatusMap[worker_ip_port] = [workerstatus,0]
                    continue
                oldworkerstatus = workerstatusMap[worker_ip_port][0]
                times = workerstatusMap[worker_ip_port][1]
                if workerstatus == oldworkerstatus:
                    #三次之后做出反应
                    if times == 2:
                        self.get_lock() 
                        self.response_with_workstatus(worker_ip_port,workerstatus)
                        self.release_lock()
                        workerstatusMap[worker_ip_port] = [workerstatus,0]
                    else:
                        workerstatusMap[worker_ip_port] = [workerstatus,times+1]
                else:
                    workerstatusMap[worker_ip_port] = [workerstatus,0]
                    
    def response_with_workstatus(self,worker_ip_port,workerstatus):
        if workerstatus == status.WORKER.ready:
            localWorkerstatus = self.workerPool.get_worker_status(worker_ip_port)
            #workerStatus＝＝３(shutdown),说明已经把对应的task复位了
            if localWorkerstatus == status.WORKER.shutdown or localWorkerstatus == status.WORKER.recover \
                or localWorkerstatus == status.WORKER.busy or localWorkerstatus == status.WORKER.error:
                self.workerPool.set_worker_status(worker_ip_port,-1,status.WORKER.ready)
        elif workerstatus == status.WORKER.recover:
            self.workerPool.set_worker_status(worker_ip_port,-1,status.WORKER.busy)
        elif workerstatus == status.WORKER.error:
            #把执行出错的任务放入failedtasklist中
            taskInfo = self.processPool.get_taskInfo_with_worker(worker_ip_port)
            self.reset_task_status(taskInfo)
            #设置worker的状态
            self.workerPool.set_worker_status(worker_ip_port,-1,status.WORKER.ready)
        elif workerstatus == status.WORKER.shutdown:
            localWorkerstatus = self.workerPool.get_worker_status(worker_ip_port)
            if localWorkerstatus == status.WORKER.shutdown or localWorkerstatus == status.WORKER.recover:
                return
            self.workerPool.set_worker_status(worker_ip_port,-1,status.WORKER.shutdown)
            #查看该worker对应的task
            taskInfo = self.processPool.get_taskInfo_with_worker(worker_ip_port)
            pos = reset_task_status(self.taskPool,taskInfo)
            #把该worker对应的信息也进行更新
            if pos != -1:
                taskID = taskInfo[1]
                pair = (decodeID.taskID_just_decode(taskID)).split(' ')
                newTaskID = generateID.taskID(pair[0]+' '+pair[1]+' '+str(pos)+' '+'False')
                self.processPool.put_a_process([taskInfo[0],newTaskID],worker_ip_port)
                
    def get_workerstatus(self,worker_ip_port):
        s = xmlrpclib.ServerProxy('http://'+worker_ip_port)
        workerstatus = s.get_workerstatus()
        return workerstatus
    def ignore_this_function(self,mybool):
        if mybool:
            return 1
        else:
            return 2
    
def reset_task_status(taskPool,taskInfo):
    '''
    :return 返回在failedtasklist中的位置:
    '''
    if taskInfo:
        pos,isInTaskList = decodeID.taskID(taskInfo[1])[2:]
        if isInTaskList == True:
            #monitor还没有把对应的task放入failedtasklist,设置为3，放入failedtasklist
            if taskPool.get_task_status(pos)!=status.TASK.failed:
                if taskPool.set_task_status(pos,status.TASK.failed) == True:
                    pos = taskPool.put_failed_task([taskInfo[0],status.TASK.ready])
                    return pos
        else:
            taskPool.set_failedtask_status(pos,status.TASK.ready)
            return pos
    return -1
            
       
                    
                    
                
    
    
    
    
    
    
    