#encoding=utf-8
import os,sys
path = os.path.abspath(__file__)
absdir = path[0:path.rfind('/')]
sys.path.append(absdir[0:absdir.rfind('/',0,len(absdir))])

import xmlrpclib   
from common.sdk import s3client
from utils import getmachineinfo,generateID,decodeID
from common.enum import status
import threading
import logging
log = logging.getLogger('root')
class ProcessPool:
    lock = threading.Lock()
    def __init__(self,taskPool,workerPool):
        self.taskPool = taskPool
        self.workerPool = workerPool
        self.processPool = dict() 
        
    def generate_a_process(self,taskInfo,worker,desClient):
        ProcessPool.lock.acquire()
        self.processPool[worker] = taskInfo
        task = taskInfo[0]
        keyForTaskPath = task[4]
        pair = keyForTaskPath.split('/')
        log.info('(round:'+pair[3].strip()+' taskNumber:'+pair[4].strip()+') is allocated to '+'('+worker+')')
        thread = threading.Thread(target=self.assign_task, args=(taskInfo,worker,desClient))
        thread.start()
        ProcessPool.lock.release()
        return True
    def clear_a_progress(self,worker):
        if self.processPool.has_key(worker):
            self.processPool[worker] = None
            return False
        else:
            return True
    def put_a_process(self,taskInfo,worker):
        #修改一个worker所对应的task的信息
        self.processPool[worker] = taskInfo
    def get_taskInfo_with_worker(self,worker):
        #使用worker作为key获取task的信息（taskInfo）
        if self.processPool.has_key(worker) and self.processPool[worker]:
            return self.processPool[worker]
        return None
    
    def assign_task(self,taskInfo,worker,desClient):
        task = taskInfo[0]
        [destination,keyForTaskPath,master] = task[3:6]
        taskID = taskInfo[1]
        workerstatusContent = worker + '\n' + master
        taskstatusContent = 'ready' + '\n' + taskID
        if (not (desClient.put_object( destination['bucketName'], keyForTaskPath+'workerstatus', workerstatusContent)))\
            or (not (desClient.put_object( destination['bucketName'], keyForTaskPath+'taskstatus', taskstatusContent))):
            """if failed,task and worker reset"""
            log.info('write workerstatus or taskstatus error ')
            #反编码taskID,得到pos和是否在tasklist中
            pos,isInTaskList = decodeID.taskID(taskID)[2:]
            if isInTaskList:
                self.taskPool.set_task_status(pos,status.TASK.failed)
                self.taskPool.put_failed_task([task,status.TASK.ready])
            else:
                self.taskPool.set_failedtask_status(pos,status.TASK.ready)
            self.workerPool.set_worker_status(worker,-1,status.WORKER.ready)
            exit(1)
        try:
            s = xmlrpclib.ServerProxy('http://'+worker)
            s.run_task_thread(taskInfo)
            return
        except Exception,e:
            log.error(e)
            log.error( 'can not connect '+worker+',and you can try to restart it!')
            
        
    
    
    
    