#encoding=utf-8
import os,sys
path = os.path.abspath(__file__)
absdir = path[0:path.rfind('/')]
sys.path.append(absdir[0:absdir.rfind('/',0,len(absdir))])

import xmlrpclib   
import threading
from SimpleXMLRPCServer import SimpleXMLRPCRequestHandler
from SimpleXMLRPCServer import SimpleXMLRPCServer
from SocketServer import ThreadingMixIn
from utils  import getmachineinfo,decodeID,generateID,timeoperation
from common.enum import status
import monitor
import time
import logging
log = logging.getLogger('root')

class ReceiveMessage:
    
    isCreateReceiveMessageServerOK = -1
    finishedFiles = 0
    finishedSize = 0
    failed = 0
    NumbersFinishedTasks = 0
    #记录一下当前时间，用来计算剩余时间
    desClient = None
    startTime = time.time()
    def __init__(self,taskPool=None,workerPool=None,processPool = None,monitor = None):
        
        self.taskPool = taskPool
        self.workerPool = workerPool
        self.processPool = processPool
        self.monitor = monitor
        self.probeResponseList = list()
        
    
    def sendmessage(self,message):
        self.monitor.get_lock()
        [taskFinishedResult,taskInfo,worker_ip_port] = message
        task = taskInfo[0]
        taskID = taskInfo[1]
        localTaskInfo = self.processPool.get_taskInfo_with_worker(worker_ip_port)
        if (not localTaskInfo) or localTaskInfo[1] != taskID:
            if not localTaskInfo:
                log.warning('we didn\'t have any record about ' +taskID)
            else:
                log.warning(localTaskInfo[1] + ' and ' + taskID + 'are not the same!')
            self.monitor.release_lock()
            return False
        ReceiveMessage.NumbersFinishedTasks += 1
        """设置对应的task的状态"""
        pos,isInTaskList = decodeID.taskID(taskID)[2:]
        if isInTaskList:
            self.taskPool.set_task_status(pos,status.TASK.done)
        else:
            self.taskPool.set_failedtask_status(pos,status.TASK.done)
        ReceiveMessage.finishedFiles += taskFinishedResult[2]
        ReceiveMessage.finishedSize += long(taskFinishedResult[4])
        ReceiveMessage.failed += long(taskFinishedResult[3])
        jobInfo = self.taskPool.get_all_files_size()
        self.generate_probe_response(jobInfo)
        record_task_finished_result(taskFinishedResult, task[4],jobInfo,self.taskPool.is_generating_tasks())
        self.workerPool.set_worker_status(worker_ip_port,-1,status.WORKER.ready)
        #在processPool中清空该worker对应的task
        self.processPool.clear_a_progress(worker_ip_port)
        self.monitor.release_lock()
        return True
    
    def generate_probe_response(self,jobInfo):
        #probe response
        probeString = 'tasks:'+str(ReceiveMessage.NumbersFinishedTasks)+'/'+str(self.taskPool.get_taskNumbers())+' '+\
                      'files:'+str(ReceiveMessage.finishedFiles)+'/'+str(jobInfo[0])+' '+\
                      'size:'+str(ReceiveMessage.finishedSize)+'/'+str(jobInfo[1])+'|'
        if ReceiveMessage.finishedSize != 0:
            probeString += timeoperation.s_to_hms_string(
                                (jobInfo[1]-ReceiveMessage.finishedSize)*(time.time()-ReceiveMessage.startTime)\
                                /ReceiveMessage.finishedSize
                            ) + \
                            '\n'
        else:
            probeString += 'no file finished' + '\n'
                 
        if len(self.probeResponseList) == 0:
            self.probeResponseList.append(probeString)
        else:
            self.probeResponseList[0] = probeString
        
    def register_worker(self,worker_ip_port):
        self.monitor.get_lock()
        taskInfo = self.processPool.get_taskInfo_with_worker(worker_ip_port)
        taskID = taskInfo[1]
        pos,isInTaskList = decodeID.taskID(taskID)[2:]
        workerStatus = self.workerPool.get_worker_status(worker_ip_port)
        if workerStatus == status.WORKER.shutdown:
            self.workerPool.set_worker_status(worker_ip_port,-1,status.WORKER.recover)
            log.info('we have detected '+str(worker_ip_port)+' is shutdown')
            log.info(worker_ip_port + ' resgister successfully! the value of pos is '+str(pos))  
            self.monitor.release_lock()
            return pos
        self.workerPool.set_worker_status(worker_ip_port,-1,status.WORKER.recover)        
        #pos　是该task在failedtasklist中的位置
        pos = monitor.reset_task_status(self.taskPool,taskInfo)
        log.info(worker_ip_port + ' resgister successfully! the value of pos is '+str(pos))   
        self.monitor.release_lock()
        return pos
        
    def continue_lasttask(self,worker_ip_port,pos):
        '''
        :param pos:是task在failedtasklist中的位置
        '''
        self.monitor.get_lock()
        log.info(str(worker_ip_port)+' try to recover the task whose position is '+str(pos) +' in taskfailedlist')
        if not self.taskPool.set_failedtask_status(pos,status.TASK.dispatched,status.TASK.ready):
            log.info('agree the worker:' + str(worker_ip_port) + 'to recover')
            self.monitor.release_lock()
            return False
        else: 
            log.info('agree the worker:' + str(worker_ip_port) + 'to recover')
            taskInfo = self.processPool.get_taskInfo_with_worker(worker_ip_port)
            self.processPool.generate_a_process(taskInfo,worker_ip_port,ReceiveMessage.desClient)
            self.monitor.release_lock()
            return True
        
    def probe_request(self):
        responseString = ''
        currentRound = self.taskPool.get_round_info()[2]
        responseString += 'this is a master,round:'+str(currentRound)
        if self.taskPool.is_generating_tasks():
            responseString += ',generating tasks now'+'\n'
        else:
            responseString += ',executing tasks now'+'\n'
        if len(self.probeResponseList) == 0:
            responseString += 'no tasks have been finished yet!\n'
        for i in range(len(self.probeResponseList)):
            responseString += self.probeResponseList[i]
        return responseString
    def test(self):
        pass
    
def init():
    ReceiveMessage.startTime = time.time()
    ReceiveMessage.finishedFiles = 0
    ReceiveMessage.finishedSize = 0
    ReceiveMessage.failed = 0
    ReceiveMessage.NumbersFinishedTasks = 0
    
def get_round_finishedInfo():
    return [ReceiveMessage.finishedFiles,ReceiveMessage.finishedSize]

def new_thread(master_ip_port,taskPool=None,workerPool=None,processPool = None,monitor = None):
    pair = master_ip_port.split(':')
    #ip = pair[0]
    ip = '0.0.0.0'
    port = long(pair[1])
    try:
        server = SimpleXMLRPCServer((ip, port),allow_none=True,logRequests=False)  
        server.register_instance(ReceiveMessage(taskPool,workerPool,processPool,monitor))
        ReceiveMessage.isCreateReceiveMessageServerOK = 1
        server.serve_forever()
        
    except Exception,e:
        ReceiveMessage.isCreateReceiveMessageServerOK = 0
        log.error('create simplexmlrpc server:'+str(ip)+' '+str(port)+' failed')
        log.error(e)
    
def create_rpc_server(master_ip_port,taskPool=None,workerPool=None,processPool = None,monitor = None):
    th = threading.Thread(target=new_thread, args=(master_ip_port,taskPool,workerPool,processPool,monitor))
    th.setDaemon(True)
    th.start()

def record_task_finished_result(taskFinishedResult,keyForTaskPath,jobInfo,isGeneratingTasks = False):
    
    pair = keyForTaskPath.split('/')
    log.info('the task of '+'(round:'+pair[3].strip()\
                            +' taskNumber:'+pair[4].strip()\
                            +') has finished. \t'\
                            +'the cost time is '+ str(taskFinishedResult[5])+'s'\
                            +' and the average rate is '+str(taskFinishedResult[6])+'KB/s'
            )
    if isGeneratingTasks == False:
        mystr = 'succeeded:'+str(ReceiveMessage.finishedFiles)+'/'+str(jobInfo[0])+\
                ' failed:'+str(long(ReceiveMessage.failed))+'/'+str(jobInfo[0])+\
                         ' size:'+str(ReceiveMessage.finishedSize)+'/'+str(jobInfo[1])
        if long(jobInfo[1]) != 0:
            mystr += ','+str(round(100*ReceiveMessage.finishedSize/float(jobInfo[1]),2))+'%'
        log.info(mystr)
    
    
    
    
    
    
    
