#encoding=utf-8
import sys,os
path = os.path.abspath(__file__)
absdir = path[0:path.rfind('/')]
absdir = absdir[0:absdir.rfind('/')]
sys.path.append(absdir[0:absdir.rfind('/',0,len(absdir))])

import getpathinfo
from common.const import type
import logging
import time
import random
import string
log = logging.getLogger('root')

#read
def read_config(configFile,job,workerlist):
    
    for line in configFile:
        mystr = line.strip('\n').strip()
        if len(mystr) == 0 or mystr.startswith("#",0,1) or mystr.count("=") != 1:
            continue
        pair = mystr.split("=")
        for i in range(0,len(pair)):
            pair[i] = pair[i].strip()
            
        if mystr.startswith('worker'):
            workerlist.append(pair[1])
        else:
            job[pair[0]] = pair[1]
    return True

#check 
def check_config_and_fillin_default(job,workerlist):
    if not check_worker(workerlist):
        return None
    if not check_job(job):
        return None
    return True

def check_worker(workerList):
    for worker in workerList:
        if not worker:
            log.error('Please check the configuration of worker')
            return None
    return True
    
def check_job(job):
    
    if not check_item_must_have(job, 'master'):
        return False
    #如果用户设置了job-ID,就使用用户设置的；否则，使用time+随机数作为job-ID
    if not check_optional_item(job, 'job-ID',None,generate_jobID()):
        return False
    if not check_item_must_have(job, 'job-type',['transfer','check']):
        return False
    if not check_src(job):
        return False
    if not check_des(job):
        return False
    if not check_sync(job):
        return False
    if not check_transfer_check_common(job):
        return False
    if not check_transfer(job):
        return False
    if not check_check(job):
        return False
    return True
def generate_jobID():
    return time.strftime('%Y-%m-%d %H:%M:%S',time.localtime(time.time()))+'_'+''.join(random.sample(string.ascii_letters + string.digits, 8))
    

def check_src(job):
    if not check_optional_item(job,'src-filetype',['s3file','diskfile','qiniufile','aliyunfile','tencentfile', 'baidufile'],'s3file'):
        return False
    if not check_optional_item(job,'src-file-list', None, ''):
        return False
    if job['src-filetype'] == type.FileType.DiskFile:
        if not check_item_must_have(job, 'src-absolutepath'):
            return False
        elif not job['src-absolutepath'].endswith('/'):
            job['src-absolutepath'] += '/'
    else:
        if not check_item_must_have(job, 'src-accesskey'):
            return False
        if not check_item_must_have(job, 'src-secretkey'):
            return False
        if not check_item_must_have(job, 'src-endpoint'):
            return False
        if not check_item_must_have(job, 'src-bucketName'):
            return False
        if job.has_key('src-key') and job['src-key'] and job['src-key'].endswith('/')==False:
            job['src-key'] += '/'

    if not job['src-file-list'].startswith('/') and job['src-file-list']:
        job['src-file-list'] = getpathinfo.get_s3transfer_home(os.path.abspath(__file__)) + job['src-file-list']
        
    return True

def check_des(job):
    if not check_item_must_have(job, 'des-accesskey'):
        return False
    if not check_item_must_have(job, 'des-secretkey'):
        return False
    if not check_item_must_have(job, 'des-endpoint'):
        return False
    if not check_item_must_have(job, 'des-bucketName'):
        return False
    if job.has_key('des-key') and job['des-key'] and job['des-key'].endswith('/')==False:
        job['des-key'] += '/'

    return True

def check_sync(job):
    if not check_optional_item(job, 'sync-enable-increment',['True','False'] , 'True'):
        return False
    if not check_optional_item(job, 'sync-lastmodify', [] , '1970-01-01 00:00:00'):
        return False
    try:
        job['sync-lastmodify'] = str(time.mktime(time.strptime(job['sync-lastmodify'], '%Y-%m-%d %H:%M:%S')))
    except Exception,e:
        log.error(e)
        return False
    return True
    
def check_transfer_check_common(job):
    if not check_optional_item(job, 'task-size',None,5120):
        return False
    if not check_optional_item(job, 'task-filenumbers',None,50000):
        return False
    if not check_optional_item(job, 'round',None,2):
        return False
    return True

def check_transfer(job):
    if not check_optional_item(job, 'transfer-is-continue',['True','False'],'True'):
        return False
    if not check_optional_item(job, 'transfer-error-output',None,job['job-ID']+'-transfer-error-list.txt'):
        return False
    return True

def check_check(job):
    if not check_optional_item(job, 'check-time',['never','future','now'],'future'):
        return False
    if not check_optional_item(job, 'check-mode',['head','md5'],'head'):
        return False
    if not check_optional_item(job, 'check-is-continue',['True','False'],'True'):
        return False
    if not check_optional_item(job, 'check-error-output',None,job['job-ID']+'-check-error-list.txt'):
        return False
    if not check_optional_item(job, 'check-md5-output',None,job['job-ID']+'-check-md5-list.txt'):
        return False
    return True

#check_job using
def check_item_must_have(job,item,options=[]):
    if (not job.has_key(item)) or (not job[item]):
        log.error('Please check the configuration of '+item)
        return  False
    if options and (not job[item] in options):
        log.error('Please check the configuration of '+item)
        return False
    return True
#check_job using 
def check_optional_item(job,item,options=[],default=''):
    if job.has_key(item) and job[item]:
        if options and (not (job[item] in options)):
            log.error('Please check the configuration of '+item)
            return False
        else:
            return True
    job[item] = default
    return True
        

if __name__ == '__main__':
    pair = 'worker='.split('=')
    workerList = list()
    workerList.append(pair[1])
    check_worker(workerList)
    
    
    
    
    
    
    