#encoding=utf-8
#encoding=utf-8
import os,sys
path = os.path.abspath(__file__)
absdir = path[0:path.rfind('/')]
sys.path.append(absdir[0:absdir.rfind('/',0,len(absdir))])

from multiprocessing import Queue
from time import sleep,ctime
from collections import deque
from common.enum import status
import thread
import xmlrpclib
import logging

log = logging.getLogger('root')

class WorkerPool:
    lockWorkerQueue = thread.allocate_lock()
    def __init__(self):
        self.workerqueue = deque()
    def put(self,worker):
        workerStatus = self.test_worker_status(worker)
        self.workerqueue.append([worker,workerStatus])
    def set_worker_status(self,worker_ip_port,pos=-1,status=0,oldstatus=-1):
        WorkerPool.lockWorkerQueue.acquire()
        if pos == -1:
            """找worker对应的位置"""
            for i in range(len(self.workerqueue)):
                if self.workerqueue[i][0]==worker_ip_port:
                    pos = i
                    break
        if pos == -1:
            WorkerPool.lockWorkerQueue.release()
            return False
        if oldstatus != -1:
            if self.workerqueue[pos][1] != oldstatus:
                WorkerPool.lockWorkerQueue.release()
                return False
        self.workerqueue[pos][1] = status
        WorkerPool.lockWorkerQueue.release()
        return True
    def get_worker_status(self,worker_ip_port):
        for i in range(len(self.workerqueue)):
            if self.workerqueue[i][0]==worker_ip_port:
                return self.workerqueue[i][1]
    def get(self):
        times = 0
        while times < 5 or self.get_worker_avaliable_count():
            for i in range(len(self.workerqueue)):
                if self.workerqueue[i][1] == status.WORKER.ready:
                    if self.set_worker_status(None, i, status.WORKER.busy, status.WORKER.ready):
                        return self.workerqueue[i][0]
            sleep(10)
            if self.get_worker_avaliable_count() == 0:
                times += 1
        return None
    def get_workerqueue(self):
        return self.workerqueue
            
    def empty(self):
        if len(self.workerqueue) == 0:
            return True;
        else:
            return None
    def get_worker_queue_len(self):
        return len(self.workerqueue)
    def get_worker_avaliable_count(self):
        cnt = 0
        for i in range(len(self.workerqueue)):
            if self.workerqueue[i][1]!=3:
                cnt+=1
        return cnt
    def is_workers_all_ready(self):
        for i in range(len(self.workerqueue)):
            if self.workerqueue[i][1]==status.WORKER.ready or self.workerqueue[i][1]==status.WORKER.shutdown:
                pass
            else:
                return False
        return True
        
    def test_worker_status(self,worker):
        #之所以叫test,是因为是去调用worker的rpc函数来得到worker的信息，区别于get_worker_status
        try:
            s = xmlrpclib.ServerProxy('http://'+worker)
            workerstatus = s.get_workerstatus()
            if workerstatus == status.WORKER.ready:
                log.info(worker + ' is ready')
            elif workerstatus == status.WORKER.busy:
                log.info(worker + ' is busy')
            elif workerstatus == status.WORKER.error:
                log.info(worker + ' can be used now')
                return status.WORKER.ready
            return workerstatus
        except Exception,e:
            log.error(e)
            log.info(worker+' is not ready,please check it')
            return status.WORKER.shutdown
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        