#encoding=utf-8
'''
Created on Dec 3, 2017

@author: eric

probe　用来探测master和worker的状态，输入参数很简单，只有想要查看的master或worker的ip和port,运行方法如下：
python probe.py ip:port
我们将返回一些状态信息，方便用户查看
'''
import sys,os
from SimpleXMLRPCServer import SimpleXMLRPCServer
from SimpleXMLRPCServer import SimpleXMLRPCRequestHandler
import xmlrpclib

def probe_ip_port(ip_port):
    print ip_port
    try:
        s = xmlrpclib.ServerProxy('http://'+ip_port)
        re = s.probe_request()
        #直接打印re
        print re
    except Exception,e:
        print e
        print 'please check the worker,maybe shutdown!\n'
def probe_file(filename):
    try:
        myfile = open(os.getcwd()+'/'+filename,'r')
    except Exception,e:
        print e
        return 
    for line in myfile:
        line = line.strip('\n').strip()
        if len(line) == 0 or line.startswith("#",0,1) \
            or line.count("=") != 1:
            continue
        if line.startswith('worker') or line.startswith('master'):
            pair = line.split("=")
            for i in range(0,len(pair)):
                pair[i] = pair[i].strip()
            probe_ip_port(pair[1])
    
def probe(args):
    if args[1] == '-h':
        probe_help()
    elif args[1] == '-f':
        if len(args) == 2:
            print 'there must be a file following "-f"'
        probe_file(args[2])
    elif args[1] == '-ip_port':
        if len(args) == 2:
            print 'there must be a "ip:port" following "-ip_port"'
        probe_ip_port(args[2])
        
def probe_help():
    print   'this document to help you to use probe,and to use probe you must set the options:'
    print   '    -h    this document'
    print   '    -f    the file the probe will read,the format is:'
    print   '            master=ip:port'
    print   '            worker=ip:port'
    print   '    -ip_port    ip:port you want to check'
if __name__ == '__main__':
    
    if len(sys.argv) == 1:
        probe_help()
    else:
        probe(sys.argv)


