#encoding=utf-8
import os,sys
path = os.path.abspath(__file__)
absdir = path[0:path.rfind('/')]
sys.path.append(absdir[0:absdir.rfind('/',0,len(absdir))])

import json
from common.sdk import s3client
from utils import readdata
import xmlrpclib   
import logging
log = logging.getLogger('root')

def register_and_continue_unfinished(absdir,maps):
    taskInfo = read_para(absdir+'taskinfo/para')
    if not taskInfo:
        log.error('read task information failed, and we will give up registering.')
        return None
    task = taskInfo[0]
    [jobID,jobType,source,destination,keyForTaskPath,master,checkMode,sync] = task
    desClient = s3client.S3Client(destination['accessKey'],destination['secretKey'],destination['endpoint'])
    pos = register_to_master(destination,keyForTaskPath,desClient)
    if pos == -1:
        return None
    if maps['is-continue'] == 'False':
        log.error('you set is-continue "False",and we won\'t try to recover.')
        return None
    pair = keyForTaskPath.split('/')
    log.info('we detect a '+jobType+'-task didn\'t finish,job-ID:'+jobID+' des-bucket:'+\
             destination['bucketName']+', '+pair[2]+', '+pair[3])
    objectstatusDict = read_objectstatus(absdir+'taskinfo/objectstatus')
    lines = readdata.readlines(desClient, destination['bucketName'], keyForTaskPath+'taskstatus')
    if not lines:
        return None
    line = (lines.readline()).strip()
    if line == 'done':
        return None
    if objectstatusDict and is_continue_unfinished_task(destination,keyForTaskPath,desClient,pos):
        return objectstatusDict
    else:
        return None
    
def is_continue_unfinished_task(destination,keyForTaskPath,desClient,pos):
    lines = readdata.readlines(desClient, destination['bucketName'], keyForTaskPath+'workerstatus')
    if not lines:
        return False
    worker_ip_port = lines.readline().strip('\n')
    master_ip_port = lines.readline().strip('\n')
    try:
        s = xmlrpclib.ServerProxy('http://'+master_ip_port)
        returnVal = s.continue_lasttask(worker_ip_port,pos)
        if returnVal == False:
            return False
        log.info("continue the unfinished task")
        return True
    except Exception,e:
        log.error(e)
        log.error( "we can't connect "+master_ip_port)
        return False
    
def register_to_master(destination,keyForTaskPath,desClient):
    lines = readdata.readlines(desClient, destination['bucketName'], keyForTaskPath+'workerstatus')
    if not lines:
        return False
    worker_ip_port = lines.readline().strip('\n')
    master_ip_port = lines.readline().strip('\n')
    try:
        s = xmlrpclib.ServerProxy('http://'+master_ip_port)
        pos = s.register_worker(worker_ip_port)
        if pos == -1:
            raise Exception
        return pos
    except Exception,e:
        log.error(e)
        log.error('register to '+str(master_ip_port)+' failed!')
        return -1

def read_objectstatus(objectstatusFileName):
    try:
        objectstatusDict = dict()
        objectstatusFile = open(objectstatusFileName,'r')
        for line in objectstatusFile:
            mystr = line.strip('\n').strip()
            pair = mystr.split('\t')
            for i in range(0,len(pair)):
                pair[i] = pair[i].strip()
            objectstatusDict[pair[0]] = pair[1]
        objectstatusFile.close()
        return objectstatusDict
    except IOError,e:
        log.error(e)
        return None
    except Exception,e:
        """写入的filestatus可能是不完整的，遇到错误，返回前面已成功读取的就可以了"""
        return objectstatusDict
        
def read_para(paraFileName):
    try:
        myfile = open(paraFileName,'r')
        para=json.loads(myfile.read())
        myfile.close()
        return para
    except IOError,e:
        log.error(e)
        return None
        
        
        
        
        