#coding=utf-8
import os,sys
path = os.path.abspath(__file__)
absdir = path[0:path.rfind('/')]
sys.path.append(absdir[0:absdir.rfind('/',0,len(absdir))])
from utils import setlogging,getpathinfo,timeoperation

absdir = getpathinfo.get_absdir(os.path.abspath(__file__))
logsdir = getpathinfo.get_logs_dir(os.path.abspath(__file__))
logFileName = 'log-worker-' + absdir[absdir[0:len(absdir)-1].rfind('/')+1:len(absdir)-1] + '.txt'
setlogging.set_logging(logsdir+logFileName)
import sys
reload(sys)
sys.setdefaultencoding('utf8')
from SimpleXMLRPCServer import SimpleXMLRPCServer
from common.sdk import s3client
from utils import configoperation,readdata,timeoperation
from common.enum import status
import logging
import client
import time
import xmlrpclib
import recover
import savetolocal
import threading
from SocketServer import ThreadingMixIn

"""异步的server类"""
class ThreadXMLRPCServer(ThreadingMixIn, SimpleXMLRPCServer):
    pass
class StreamingRPC(object):
    lockbuild = threading.Lock()
    lockruntask = threading.Lock()
    DiskFileListFileNumbers = 20*10000
    def __init__(self,objectstatusDict,absdir):
        self.absdir = absdir
        self.probeResponseList = list()
        self.log = logging.getLogger('root')
        if objectstatusDict:
            self.workerstatus = status.WORKER.recover
        else:
            self.workerstatus = status.WORKER.ready
        self.objectstatusDict = objectstatusDict
    
    def run_task_thread(self,taskInfo):
        th = threading.Thread(target=self.run_task, args=(taskInfo,))
        th.setDaemon(True)
        th.start()
        return True
    def run_task(self,taskInfo):
        """save taskInfo to file(paras)"""
        self.lockruntask.acquire()
        objectstatusDict = self.objectstatusDict
        self.objectstatusDict = None
        self.workerstatus = status.WORKER.busy
        self.probeResponseList[:] = []
        if not savetolocal.save_para(taskInfo,self.absdir):
            self.workerstatus = status.WORKER.ready
            self.lockruntask.release()
            return
        task = taskInfo[0]
        taskID = taskInfo[1]
        [jobID,jobType,source,destination,keyForTaskPath] = task[0:5]
        pair = keyForTaskPath.split('/')
        self.log.info('start to execute a '+jobType+'-task,job-ID:'+jobID+' '+pair[3].strip()+' '+pair[4].strip())
        self.probeResponseList.append(jobType+' job,ID:'+jobID+'round:'+pair[3].strip() + ' taskNumber:'+pair[4].strip() + '\n')
        desClient = s3client.S3Client(destination['accessKey'],destination['secretKey'],destination['endpoint'])
        lines = readdata.readlines(desClient, destination['bucketName'], keyForTaskPath+"filelist")
        if not lines:
            self.workerstatus = status.WORKER.ready
            self.lockruntask.release()
            return False
        try:
            myclient = client.Client(lines,taskInfo,objectstatusDict,self.probeResponseList,self.absdir)
            taskstatusContent = 'running' + '\n' + taskID
            self.put_taskstatus(desClient, destination['bucketName'],keyForTaskPath+'taskstatus', taskstatusContent)
            re = myclient.execute()
            taskstatusContent = 'done' + '\n' + taskID
            self.put_taskstatus(desClient, destination['bucketName'],keyForTaskPath+'taskstatus', taskstatusContent)
            message = list()
            message.append(re)
            message.append(taskInfo)
            if not self.sendmessage_to_master(desClient,destination,keyForTaskPath,message):
                raise Exception
            else:
                savetolocal.delete_local_data(self.absdir)
                self.workerstatus = status.WORKER.ready
                return True
        except SystemExit:
            self.workerstatus = status.WORKER.ready
            self.log.info('worker is ready')
            return False
        except Exception,e:
            self.log.error(e)
            self.workerstatus = status.WORKER.ready
            self.log.info('worker is ready')
            return False
        finally:
            self.lockruntask.release()
            
    def sendmessage_to_master(self,desClient,destination,keyForTaskPath,message):
        lines = desClient.get_object_with_stream(destination['bucketName'], keyForTaskPath+'workerstatus')
        if not lines:
            exit(1)
        worker_ip_port = lines.readline().strip('\n').strip()
        message.append(worker_ip_port)
        master_ip_port = lines.readline().strip('\n').strip()
        try:
            s = xmlrpclib.ServerProxy('http://'+master_ip_port)
            returnVal = s.sendmessage(message)
            pair = keyForTaskPath.split('/')
            self.log.info(str(returnVal))
            self.log.info('execute the task successfully,round:'+pair[2].strip()\
                               + ' taskNumber:'+pair[3].strip())
            return True
        except Exception,e:
            self.log.error(e)
            self.log.error('send message to '+master_ip_port+ ' failed')
            return False
            
    def put_taskstatus(self,client,bucketName,keyname,status):
        if not (client.put_object(bucketName,keyname,status)):
            exit(1)
        return True
    
    def run_build_list(self,path,accessKey,secretKey,endpoint,bucketName,fileNamePrefix,sync):
        th = threading.Thread(target=self.build_list, args=(path,accessKey,secretKey,endpoint,bucketName,fileNamePrefix,sync,))
        th.setDaemon(True)
        th.start()
        return True
    
    def build_list(self,path,accessKey,secretKey,endpoint,bucketName,fileNamePrefix,sync):
        try:
            self.lockbuild.acquire()
            self.log.info("start to generate file list")
            jobFileNumbers = 0
            jobSize = 0
            #文件列表的分割方法：以文件个数分割，每满100万个，存到下一个文件中
            fileNumbersCount = 0
            filelistNumber = 0
            filelist = list()
            length = len(path)
            desClient = s3client.S3Client(accessKey,secretKey,endpoint)
            for root, dirs, files in os.walk(path, topdown=False):
                for name in files:
                    if fileNumbersCount >= StreamingRPC.DiskFileListFileNumbers:
                        if not desClient.put_object( bucketName,fileNamePrefix+"filelist"+str(filelistNumber), '\n'.join(filelist)):
                            return False
                        self.log.info('filelist'+str(filelistNumber)+'is created,saved in '+fileNamePrefix+"filelist"+str(filelistNumber) )
                        fileNumbersCount = 0
                        filelistNumber+=1
                        filelist[:] = []
                    abspath = os.path.join(root, name)
                    lastmodify = os.path.getmtime(abspath)
                    if not timeoperation.isBetween(float(lastmodify), float(sync['lastmodify']), float(sync['starttime'])):
                        self.log.info('the modfiy time:'+timeoperation.fmt_time(lastmodify)+' of '+abspath+' is not between '
                                      +timeoperation.fmt_time(sync['lastmodify'])+
                                      ' and '+timeoperation.fmt_time(sync['starttime']))
                        continue
                    relativePath = abspath[length:]
                    sizeOfBytes = os.path.getsize(abspath)
                    fileNumbersCount += 1
                    filelist.append(relativePath+ '\t'+str(sizeOfBytes))
                    jobFileNumbers += 1
                    jobSize += long(sizeOfBytes)
            if fileNumbersCount != 0:
                if not desClient.put_object( bucketName,fileNamePrefix+"filelist"+str(filelistNumber), '\n'.join(filelist)):
                    return False
            filelist[:] = []
            if not desClient.put_object( bucketName,fileNamePrefix+'status', ''):
                self.log.error('fatal:you must restart the master')
                return False
            self.log.info("generate file list successfully,fileNumbers:"+str(jobFileNumbers)+' workSize:'+str(jobSize))
            return True
        except IOError:
            self.log.error("can not find the file or the file not exists!")
            return False
        finally:
            self.lockbuild.release()
        
    def get_workerstatus(self):
        currentStatus = self.workerstatus
        if currentStatus == status.WORKER.error:
            self.workerstatus = status.WORKER.ready
        return currentStatus
    def probe_request(self):
        responseString = ''
        responseString += 'this is a worker,status:'
        if self.workerstatus == status.WORKER.ready:
            responseString += 'ready'+'\n'
        elif self.workerstatus == status.WORKER.busy:
            responseString += 'busy'+'\n'
        elif self.workerstatus == status.WORKER.error:
            responseString += 'error'+'\n'
        elif self.workerstatus == status.WORKER.shutdown:
            responseString += 'shutdown'+'\n'
        elif self.workerstatus == status.WORKER.recover:
            responseString += 'recover'+'\n'
        if self.workerstatus == status.WORKER.busy:
            #添加正在执行的task信息
            for i in range(len(self.probeResponseList)):
                responseString += self.probeResponseList[i]
        return responseString

def main():
    absdir = getpathinfo.get_absdir(os.path.abspath(__file__))
    log = logging.getLogger('root')
    log.info('start to read config-worker')
    maps = configoperation.read_config(absdir+'config-worker')
    configoperation.check_config(maps)
    if maps['is-continue'] == 'True':
        objectstatusDict = recover.register_and_continue_unfinished(absdir,maps)
    else:
        objectstatusDict = None
    port = int(maps['port'])
    log.info('worker is starting,and listening on port:'+str(port))
    server = ThreadXMLRPCServer(("0.0.0.0", port),allow_none=True,logRequests=False)  
    server.register_instance(StreamingRPC(objectstatusDict,absdir))
    server.serve_forever()
    
def catch_main_except():
    log = logging.getLogger('root')
    try:
        main()
    except SystemExit,e:
        log.error(e)
    except KeyboardInterrupt:
        log.info('you have used ctrl-c to interrupt the worker,please wait or you can close the terminal to close the worker')
    finally:
        log.info("the worker is closed!")
        
if __name__ == "__main__":
    catch_main_except()
    
    
    
    
    
